]> git.ipfire.org Git - thirdparty/git.git/blame - git-sh-setup.sh
git-sh-setup: fix parseopt `eval` string underquoting
[thirdparty/git.git] / git-sh-setup.sh
CommitLineData
b33e9666
LT
1#!/bin/sh
2#
ae2b0f15
JH
3# This is included in commands that either have to be run from the toplevel
4# of the repository, or with GIT_DIR environment variable properly.
5# If the GIT_DIR does not look like the right correct git-repository,
6# it dies.
b33e9666 7
365527ad 8# Having this variable in your environment would break scripts because
e598c517 9# you would cause "cd" to be taken to unexpected places. If you
365527ad
JH
10# like CDPATH, define it for your interactive shell sessions without
11# exporting it.
12unset CDPATH
13
b33e9666 14die() {
8098a178 15 echo >&2 "$@"
b33e9666
LT
16 exit 1
17}
18
bac199b7
PH
19if test -n "$OPTIONS_SPEC"; then
20 usage() {
21 exec "$0" -h
22 }
23
cbea86fd
JH
24 [ -n "$OPTIONS_KEEPDASHDASH" ] && parseopt_extra="--keep-dashdash"
25 parsed=$(
26 echo "$OPTIONS_SPEC" |
27 git rev-parse --parseopt $parseopt_extra -- "$@"
28 ) &&
29 eval "$parsed" || exit
bac199b7
PH
30else
31 usage() {
32 die "Usage: $0 $USAGE"
33 }
34
35 if [ -z "$LONG_USAGE" ]
36 then
37 LONG_USAGE="Usage: $0 $USAGE"
38 else
39 LONG_USAGE="Usage: $0 $USAGE
40
41$LONG_USAGE"
42 fi
43
44 case "$1" in
45 -h|--h|--he|--hel|--help)
46 echo "$LONG_USAGE"
47 exit
48 esac
49fi
d025524d 50
f9474132
SP
51set_reflog_action() {
52 if [ -z "${GIT_REFLOG_ACTION:+set}" ]
53 then
54 GIT_REFLOG_ACTION="$*"
55 export GIT_REFLOG_ACTION
56 fi
57}
58
ef0c2abf 59git_editor() {
08874658
DK
60 : "${GIT_EDITOR:=$(git config core.editor)}"
61 : "${GIT_EDITOR:=${VISUAL:-${EDITOR}}}"
ef0c2abf
AR
62 case "$GIT_EDITOR,$TERM" in
63 ,dumb)
64 echo >&2 "No editor specified in GIT_EDITOR, core.editor, VISUAL,"
65 echo >&2 "or EDITOR. Tried to fall back to vi but terminal is dumb."
66 echo >&2 "Please set one of these variables to an appropriate"
67 echo >&2 "editor or run $0 with options that will not cause an"
68 echo >&2 "editor to be invoked (e.g., -m or -F for git-commit)."
69 exit 1
70 ;;
71 esac
08874658 72 eval "${GIT_EDITOR:=vi}" '"$@"'
ef0c2abf
AR
73}
74
4b441f47 75is_bare_repository () {
5be60078 76 git rev-parse --is-bare-repository
4b441f47
JH
77}
78
9fde9401 79cd_to_toplevel () {
5be60078 80 cdup=$(git rev-parse --show-cdup)
9fde9401
JH
81 if test ! -z "$cdup"
82 then
83 cd "$cdup" || {
84 echo >&2 "Cannot chdir to $cdup, the toplevel of the working tree"
85 exit 1
86 }
87 fi
88}
89
7eff28a9 90require_work_tree () {
e90fdc39 91 test $(git rev-parse --is-inside-work-tree) = true ||
7eff28a9
SP
92 die "fatal: $0 cannot be used without a working tree."
93}
94
0cae2346
JS
95get_author_ident_from_commit () {
96 pick_author_script='
97 /^author /{
98 s/'\''/'\''\\'\'\''/g
99 h
100 s/^author \([^<]*\) <[^>]*> .*$/\1/
101 s/'\''/'\''\'\'\''/g
102 s/.*/GIT_AUTHOR_NAME='\''&'\''/p
103
104 g
105 s/^author [^<]* <\([^>]*\)> .*$/\1/
106 s/'\''/'\''\'\'\''/g
107 s/.*/GIT_AUTHOR_EMAIL='\''&'\''/p
108
109 g
110 s/^author [^<]* <[^>]*> \(.*\)$/\1/
111 s/'\''/'\''\'\'\''/g
112 s/.*/GIT_AUTHOR_DATE='\''&'\''/p
113
114 q
115 }
116 '
117 encoding=$(git config i18n.commitencoding || echo UTF-8)
118 git show -s --pretty=raw --encoding="$encoding" "$1" |
119 LANG=C LC_ALL=C sed -ne "$pick_author_script"
120}
121
c8769f76 122# Make sure we are in a valid repository of a vintage we understand.
d025524d
FK
123if [ -z "$SUBDIRECTORY_OK" ]
124then
125 : ${GIT_DIR=.git}
6b9ff1e3 126 test -z "$(git rev-parse --show-cdup)" || {
120b0dfb
JH
127 exit=$?
128 echo >&2 "You need to run this command from the toplevel of the working tree."
129 exit $exit
130 }
d025524d 131else
b2bc9a30
DK
132 GIT_DIR=$(git rev-parse --git-dir) || {
133 exit=$?
134 echo >&2 "Failed to find a valid git directory."
135 exit $exit
136 }
d025524d 137fi
b2bc9a30
DK
138
139test -n "$GIT_DIR" && GIT_DIR=$(cd "$GIT_DIR" && pwd) || {
140 echo >&2 "Unable to determine absolute path of git directory"
141 exit 1
142}
143
c8769f76 144: ${GIT_OBJECT_DIRECTORY="$GIT_DIR/objects"}